searchNodes=[{"doc":"A generic behaviour for implementing 365 Defender API clients for OffBroadway.Defender365.Producer . This module defines callbacks to normalize options and receive events for Microsoft 365 Defender REST APIs. Modules that implements this behaviour should be passed as the :defender365_client option from OffBroadway.Defender365.Producer .","ref":"OffBroadway.Defender365.Client.html","title":"OffBroadway.Defender365.Client","type":"behaviour"},{"doc":"","ref":"OffBroadway.Defender365.Client.html#c:ack_message/2","title":"OffBroadway.Defender365.Client.ack_message/2","type":"callback"},{"doc":"","ref":"OffBroadway.Defender365.Client.html#c:init/1","title":"OffBroadway.Defender365.Client.init/1","type":"callback"},{"doc":"","ref":"OffBroadway.Defender365.Client.html#c:receive_messages/2","title":"OffBroadway.Defender365.Client.receive_messages/2","type":"callback"},{"doc":"","ref":"OffBroadway.Defender365.Client.html#t:messages/0","title":"OffBroadway.Defender365.Client.messages/0","type":"type"},{"doc":"This module contains ExConstructor modules for the various entities contained within an incident.","ref":"OffBroadway.Defender365.Incident.html","title":"OffBroadway.Defender365.Incident","type":"module"},{"doc":"Default API client used by OffBroadway.Defender365.Producer to receive incidents from Microsoft 365 Defender Incident APIs . An incident is a collection of related alerts that help describe an attack. Events from different entities in an organization are automatically aggregated by Microsoft Defender 365. This module implements the OffBroadway.Defender365.Client and Broadway.Acknowledger behaviours which defines callbacks for receiving and acknowledging events. The 365 Defender Incident client uses the api.security.microsoft.com endpoints for receiving incidents and is implemented using the Tesla library. Tesla is a HTTP client abstraction library which lets us easily select from a range of HTTP adapters. Please see the Tesla documentation for more information. The following quotas are enforced for the incidents API: Maximum page size is 100 incidents Maximum rate of requests is 50 calls per minute and 1500 calls per hour The following permissions are required to call the incidents API: Permission type: Application - Incident.Read.All Permission type: Application - Incident.ReadWrite.All Permission type: Delegated - Incident.Read Permission type: Delegated - Incident.ReadWrite","ref":"OffBroadway.Defender365.IncidentClient.html","title":"OffBroadway.Defender365.IncidentClient","type":"module"},{"doc":"Returns a Tesla.Client configured with middleware. Tesla.Middleware.BaseUrl middleware configured with base_url passed via opts . Tesla.Middleware.BearerAuth middleware configured with api_token passed via opts . Tesla.Middleware.Query middleware configured with query passed via opts . Tesla.Middleware.JSON middleware configured with Jason engine.","ref":"OffBroadway.Defender365.IncidentClient.html#client/1","title":"OffBroadway.Defender365.IncidentClient.client/1","type":"function"},{"doc":"","ref":"OffBroadway.Defender365.IncidentClient.html#maybe_receive_messages/4","title":"OffBroadway.Defender365.IncidentClient.maybe_receive_messages/4","type":"function"},{"doc":"","ref":"OffBroadway.Defender365.IncidentClient.html#receive_messages/3","title":"OffBroadway.Defender365.IncidentClient.receive_messages/3","type":"function"},{"doc":"OffBroadway Defender365 option definition and custom validators.","ref":"OffBroadway.Defender365.Options.html","title":"OffBroadway.Defender365.Options","type":"module"},{"doc":"","ref":"OffBroadway.Defender365.Options.html#definition/0","title":"OffBroadway.Defender365.Options.definition/0","type":"function"},{"doc":"","ref":"OffBroadway.Defender365.Options.html#type_date_time/2","title":"OffBroadway.Defender365.Options.type_date_time/2","type":"function"},{"doc":"GenStage Producer for a stream of incidents from the Microsoft 365 Defender APIs. Producer options :receive_interval - The duration (in milliseconds) for which the producer waits before making a request for more messages. Keep in mind that the 365 Defender API quota is 50 calls per minute and 1500 calls per hour. The default value is 5000 . :from_timestamp - If present, use this value to fetch incidents with &quot;lastUpdateTime&quot; greater or equal to given value. :on_success - Configures the acking behaviour for successful messages. See the &quot;Acknowledgements&quot; section below for all the possible values. The default value is :ack . :on_failure - Configures the acking behaviour for failed messages. See the &quot;Acknowledgements&quot; section below for all the possible values. The default value is :noop . :incident_client - A module that implements the OffBroadway.Defender365.Client behaviour. This module is responsible for fetching and acknowledging the messages from the 365 Defender APIs. All options passed to the producer will also be forwarded to the client. The default value is OffBroadway.Defender365.IncidentClient . :config - Required. A set of config options that overrides the default config for the incident_client module. Any option set here can also be configured in config.exs . :tenant_id - Required. Tenant ID to consume incidents for :client_id - Required. Client ID to use for obtaining authentication token :client_secret - Required. Client secret to use for obtaining authentication token Acknowledgements You can use on_success and on_failure options to control how messages are acknowledged. You can set these options when starting the Defender365 producer, or change them for each message through Broadway.Message.configure_ack/2 . By default, successful messages are acked ( :ack ) and failed messages are not ( :noop ). The possible values for :on_success and :on_failure are: :ack - acknowledge the message. The 365 defender APIs does not have any concept of acking messages because we are just consuming messages from a web api endpoint. For now we are just executing a :telemetry event for acked messages. :noop - do not acknowledge the message. No action are taken. ## Telemetry This library exposes the following telemetry events: * ` [ :off_broadway_defender365 , :receive_messages , :start ] ` - Dispatched before receiving messages from the 365 Defender APIs . * measurement : ` %{ time : System . monotonic_time } ` * metadata : ` %{ tenant_id : string , demand : integer } ` * ` [ :off_broadway_defender365 , :receive_messages , :stop ] ` - Dispatched after messages have been received from the 365 Defender APIs and &quot;wrapped&quot; . * measurement : ` %{ time : native_time } ` * metadata : ` ` ` %{ tenant_id : string , received : integer , demand : integer } ` ` ` * ` [ :off_broadway_defender365 , :receive_messages , :exception ] ` - Dispatched after a failure while receiving messages from the 365 Defender APIs . * measurement : ` %{ duration : native_time } ` * metadata : ` ` ` %{ tenant_id : string , demand : integer , kind : kind , reason : reason , stacktrace : stacktrace } ` ` ` * ` [ :off_broadway_defender365 , :receive_messages , :ack ] ` - Dispatched when acking a message . * measurement : ` %{ time : System . system_time , count : 1 } ` * meatadata : ` ` ` %{ tenant_id : string , receipt : receipt } ` ` `","ref":"OffBroadway.Defender365.Producer.html","title":"OffBroadway.Defender365.Producer","type":"module"},{"doc":"Broadway consumer acts as a consumer for incidents reported by the Microsoft 365 Defender APIs. Read the full documentation here .","ref":"readme.html","title":"OffBroadway.Defender365","type":"extras"},{"doc":"This package is available in Hex , and can be installed by adding off_broadway_defender365 to your list of dependencies in mix.exs : def deps do [ { :off_broadway_defender365 , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"OffBroadway.Defender365 - Installation","type":"extras"},{"doc":"The OffBroadway.Defender365.IncidentClient tries to read the following configuration from config.exs . # config.exs config :off_broadway_defender365 , :incident_client , base_url : System . get_env ( &quot;365DEFENDER_BASE_URL&quot; , &quot;https://api.security.microsoft.com&quot; ) , tenant_id : System . get_env ( &quot;365DEFENDER_TENANT_ID&quot; , &quot;your-tenant-id-here&quot; ) , client_id : System . get_env ( &quot;365DEFENDER_CLIENT_ID&quot; , &quot;your-client-id-here&quot; ) , client_secret : System . get_env ( &quot;365DEFENDER_CLIENT_SECRET&quot; , &quot;your-client-secret-here&quot; ) Options for the OffBroadway.Defender365.IncidentClient can be configured either in config.exs or passed as options directly to the OffBroadway.Defender365.Producer module. Options are merged, with the passed options taking precedence over those configured in config.exs . # my_broadway.ex defmodule MyBroadway do use Broadway alias Broadway.Message def start_link ( _opts ) do Broadway . start_link ( __MODULE__ , name : __MODULE__ , producer : [ module : { OffBroadway.Defender365.Producer , config : [ client_id : &quot;your-client-id-here&quot; , client_secret : &quot;your-client-secret-here&quot; , ] } ] , processors : [ default : [ ] ] , batchers : [ default : [ batch_size : 500 , batch_timeout : 5000 ] ] ) end ... callbacks ... end Processing messages In order to process incoming messages, we need to implement some callback functions. defmodule MyBroadway do use Broadway alias Broadway.Message ... start_link ... @impl true def handle_message ( _ , % Message { data : data } , _ ) do message |&gt; Message . update_data ( fn -&gt; ... whatever ... end ) end @impl true def handle_batch ( _batcher , messages , _batch_info , _context ) do IO . puts ( &quot;Received a batch of \#{ length ( messages ) } messages!&quot; ) messages end end For the sake of the example, we're not really doing anything here. Whenever we're receiving a batch of messages, we just prints out a message saying &quot;Received a batch of messages!&quot;, and for each message we run Message.update_data/2 passing a function that can process that message ie. by doing some calculations on the data or something else.","ref":"readme.html#usage","title":"OffBroadway.Defender365 - Usage","type":"extras"},{"doc":"Copyright 2022 Intility Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]